﻿using HarmonyLib;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;

public static class VRMShader
{
	public static Dictionary<string, Shader> Shaders { get; } = new Dictionary<string, Shader>();
	private static AssetBundle assetBundle;

	public static void Initialize(byte[] buf)
	{
		assetBundle = AssetBundle.LoadFromMemory(buf);
		var assets = assetBundle.LoadAllAssets<Shader>();
		foreach (var asset in assets)
		{
			Shaders.Add(asset.name, asset);
			VRMShaders.MaterialFactory.AddShaders(asset.name, asset);
			Debug.Log("[RaftVRM] Add shader: " + asset.name);
		}
	}

	public static void Destroy()
	{
		if (assetBundle != null)
		{
			assetBundle.Unload(true);
		}
	}
}