﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using UnityEngine;
using VRM;

class SpringBoneSetting
{
    public float drag;
    public float gravity;
    public float stiffness;
}

internal class VRMSpringBoneController : MonoBehaviour
{
    private Dictionary<VRMSpringBone, SpringBoneSetting> springBoneDic = new Dictionary<VRMSpringBone, SpringBoneSetting>();
    private string playerName;

    public void Setup(string playerName)
    {
        this.playerName = playerName;

        var springBones = GetComponentsInChildren<VRMSpringBone>();
        foreach (var springBone in springBones)
        {
            springBoneDic.Add(springBone, new SpringBoneSetting()
            {
                drag = springBone.m_dragForce,
                gravity = springBone.m_gravityPower,
                stiffness = springBone.m_stiffnessForce,
            });
        }
    }

    void Update()
    {
        foreach (var kv in springBoneDic)
        {
            kv.Key.m_dragForce = kv.Value.drag * RaftVRMSettings.ReadFloat(playerName, "SpringBoneDrag", 1.0f);
            kv.Key.m_gravityPower = kv.Value.gravity * RaftVRMSettings.ReadFloat(playerName, "SpringBoneGravity", 1.0f);
            kv.Key.m_stiffnessForce = kv.Value.stiffness * RaftVRMSettings.ReadFloat(playerName, "SpringBoneStiffness", 1.0f);
        }
    }
}